program memory;
{ 12.09.95:  Images erstellt und Datei Memory.ima                        }
{ 17.09.95:  erste spielbare Version mit Computermove und Ende-Screen    }


uses crt,dos,graph,intuit;

const cmax=32; xmax=8; ymax=8; nmax=2; ox=-4; oy=-12; dx=64; dy=48;
      imafile='memory.ima';
      titel=' o            U J A s    M e m o r y              o   TP6   o   V.0.999   o';

type feld=array[1..xmax,1..ymax] of integer;
     lvec=array[1..nmax] of longint;

var ima             :array[0..33] of image;
    xy1,xy2,xy3,xy4 :Koords;
    ibord1,ibord2   :array[1..4] of Border;
    itext1,itext2   :array[1..4] of Intuitext;
    strinf          :array[1..nmax] of strinfo;
    igad            :array[1..5] of Gadget;
    ok,ende,aus     :boolean;

    ch                                      :char;
    i,j,k,level,runde,ofx,ofy,typ,dran,mx,my:integer;
    punkte,gesamt                           :lvec;
    f,cram                                  :feld;
    temp                                    :string;

{ ------------------------------------------------------------------- }

procedure initimas;
var f    :file;
    ok   :boolean;
    i,anz:integer;
begin { initimas }
   assign(f,imafile);
   reset(f,1);
   for i:=0 to 33 do begin
      BlockRead(f,ima[i],sizeof(Image),anz);
      with ima[i] do begin
         anz:=imagesize(1,1,width,height);
         GetMem(p_data,anz);
         BlockRead(f,p_data^,anz,anz);
      end;
   end; { for i }
   close(f);
end;

{ ------------------------------------------------------------------- }

procedure initstructures;
var i,x,y:integer;
begin
   xy1[0]:=-1; xy1[1]:=15; xy1[2]:=-1;  xy1[3]:=-1; xy1[4]:=128; xy1[5]:=-1;
   xy2[0]:=-1; xy2[1]:=15; xy2[2]:=128; xy2[3]:=15; xy2[4]:=128; xy2[5]:=0;
   xy3[0]:=-1; xy3[1]:=15; xy3[2]:=-1;  xy3[3]:=-1; xy3[4]:=48;  xy3[5]:=-1;
   xy4[0]:=-1; xy4[1]:=15; xy4[2]:=48;  xy4[3]:=15; xy4[4]:=48;  xy4[5]:=0;

   for i:=1 to nmax do with strinf[i] do begin
      x:=0;
      y:=4;
      maxlen:=16;
      fpen:=1;
      bpen:=13;
      case i of
      1: buff:='Miezektzchen';
      2: buff:='Stachelbrchen';
      else buff:='';
      end;
      ubuff:=buff;
   end;

   for i:=1 to 4 do begin
      with ibord1[i] do begin
         if i<3 then p_ecken:=addr(xy1) else p_ecken:=addr(xy3);
         x:=0;
         y:=0;
         fpen:=1;
         bpen:=15;
         drmode:=jam1;
         ecken:=3;
         p_nextborder:=addr(ibord2[i]);
      end;
      with ibord2[i] do begin
         if i<3 then p_ecken:=addr(xy2) else p_ecken:=addr(xy4);
         x:=0;
         y:=0;
         fpen:=0;
         bpen:=15;
         drmode:=jam1;
         ecken:=3;
         p_nextborder:=nil;
      end;

      with itext1[i] do begin
         case i of
         1: begin
               x:=-38;
               itext:='Sp.1';
            end;
         2: begin
               x:=-38;
               itext:='Sp.2';
            end;
         3: begin
               x:=8;
               itext:='Neu';
            end;
         4: begin
               x:=8;
               itext:='Quit';
            end;
         end;
         y:=4;
         fpen:=1;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=addr(itext2[i]);
      end;
      itext2[i]:=itext1[i];
      with itext2[i] do begin
         x:=pred(itext1[i].x);
         fpen:=0;
         p_nexttext:=nil;
      end;

      with igad[i] do begin
         id:=i;
         height:=16;
         bpen:=15;
         hibpen:=14;
         p_loborder:=addr(ibord1[i]);
         p_hiborder:=p_loborder;
         p_loimage:=nil;
         p_hiimage:=nil;
         p_lointuitext:=addr(itext1[i]);
         p_hiintuitext:=p_lointuitext;
         onoff:=false;
         active:=true;
         p_nextgadget:=addr(igad[succ(i)]);

         case i of
         1: begin
               x:=96;
               y:=438;
               width:=128;
               gadgettyp:=strgadget;
               p_specialinfo:=addr(strinf[i]);
            end;
         2: begin
               x:=96;
               y:=456;
               width:=128;
               gadgettyp:=strgadget;
               p_specialinfo:=addr(strinf[i]);
            end;
         3: begin
               x:=584;
               y:=438;
               width:=48;
               gadgettyp:=boolgadget;
               p_specialinfo:=nil;
            end;
         4: begin
               x:=584;
               y:=456;
               width:=48;
               gadgettyp:=boolgadget;
               p_specialinfo:=nil;
            end;
         end;
      end;
   end;

   with igad[5] do begin
      id:=5;
      x:=ox+dx;
      y:=oy+dy;
      width:=xmax*dx;
      height:=ymax*dy;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=nil;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=nil;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
   end;

   RefreshGadgets(addr(igad[1]));
end;

{ ------------------------------------------------------------------- }

procedure screenaufbau(var ok:boolean);
const pal: array[0..15,0..2] of integer=
           (( 0, 0, 0),(60,60,60),( 0,27,31),(30,47,47),
            ( 0,35,14),(51,57,29),(53,28, 0),(62,50,29),
            (47, 0, 0),(57,28,28),(41, 0,41),(56,36,57),
            (33,24,24),(40,29,29),(47,35,33),(55,42,38));

var i,j:integer;
    t:string;

begin
   initscreen(ok);
   if ok then begin
      for i:=0 to 15 do begin
         setpalette(i,i);
         setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
      end;
      rectfill(0,0,639,479,13);

      { oberer Balken: }
      rectfill(8,8,631,23,15);
      setcolor(1);
      line(7,7,7,24);
      line(7,7,632,7);
      setcolor(0);
      line(7,24,632,24);
      line(632,8,632,23);
      setcolor(1);
      outtextxy(17,12,titel);
      setcolor(0);
      outtextxy(16,12,titel);

      { Anzeigen unten: }
      rectfill(232,438,571,471,14);
      setcolor(1);
      line(231,437,572,437);
      line(231,437,231,472);
      line(508,438,508,471);
      setcolor(0);
      line(231,472,572,472);
      line(572,439,572,471);
      line(507,438,507,471);
      t:='Punkte: xxxx - gesamt: xxxxx -';
      setcolor(1);
      outtextxy(249,442,t);
      outtextxy(249,460,t);
      setcolor(8);
      outtextxy(248,442,t);
      outtextxy(248,460,t);

      t:='Runde';
      setcolor(1);
      outtextxy(521,444,t);
      setcolor(8);
      outtextxy(520,444,t);
   end;
end;

{ ------------------------------------------------------------------- }

procedure screen2;
var i,j,k   :integer;
    t,t1,t2 :string;
begin
   rectfill(ox+dx,oy+dy,ox+succ(xmax)*dx,oy+succ(ymax)*dy,13);
   t:='S';
   SetTextStyle(gothicfont,horizdir,8);
   Setcolor(0);
   outtextxy(ox+dx,oy+dy,t);
   Setcolor(1);
   outtextxy(ox+dx+2,oy+dy+2,t);
   Setcolor(8);
   outtextxy(ox+dx+4,oy+dy+4,t);
   outtextxy(ox+dx+5,oy+dy+5,t);
   outtextxy(ox+dx+6,oy+dy+6,t);
   t:='ieger nach ';
   SetTextStyle(gothicfont,horizdir,5);
   Setcolor(0);
   outtextxy(ox+2*dx-8,oy+2*dy-4,t);
   t:='P';
   SetTextStyle(gothicfont,horizdir,8);
   Setcolor(0);
   outtextxy(ox+5*dx,oy+dy,t);
   Setcolor(1);
   outtextxy(ox+5*dx+2,oy+dy+2,t);
   Setcolor(8);
   outtextxy(ox+5*dx+4,oy+dy+4,t);
   outtextxy(ox+5*dx+5,oy+dy+5,t);
   outtextxy(ox+5*dx+6,oy+dy+6,t);
   t:='unkten:';
   SetTextStyle(gothicfont,horizdir,5);
   Setcolor(0);
   outtextxy(ox+6*dx-8,oy+2*dy-4,t);

   for i:=1 to 3 do begin
      drawimage(ox+dx*(i+1)+16,oy+5*dy+8,addr(ima[33]));
      drawimage(ox+dx*(i+1)+24,oy+7*dy+8,addr(ima[33]));
   end;

   for i:=1 to nmax do begin
      with igad[i].p_specialinfo^ do if length(buff)>0 then begin
         t:=buff[1];
         SetTextStyle(gothicfont,horizdir,6);
         Setcolor(0);
         outtextxy(ox+dx,oy+(2*i+1)*dy+16,t);
         Setcolor(1);
         outtextxy(ox+dx+2,oy+(2*i+1)*dy+18,t);
         Setcolor(8);
         outtextxy(ox+dx+4,oy+(2*i+1)*dy+20,t);
         outtextxy(ox+dx+5,oy+(2*i+1)*dy+21,t);
         outtextxy(ox+dx+6,oy+(2*i+1)*dy+22,t);

         if length(buff)>1 then begin
            t:=copy(buff,2,pred(length(buff)));
            SetTextStyle(gothicfont,horizdir,5);
            Setcolor(0);
            outtextxy(ox+2*dx-16,oy+(2*i+1)*dy+32,t);
         end;
      end;

      str(gesamt[i]:5,t);
      setcolor(1);
      outtextxy(ox+6*dx-1,oy+(2*i+2)*dy+31,t);
      setcolor(0);
      outtextxy(ox+6*dx,oy+(2*i+2)*dy+32,t);
      setcolor(8);
      outtextxy(ox+6*dx+1,oy+(2*i+2)*dy+33,t);
   end;
   SetTextStyle(defaultfont,horizdir,1);
end;

{ ------------------------------------------------------------------- }

procedure updatrunde(r:integer);
var t1:string;
begin
   rectfill(520,460,560,471,14);
   Str(r:4,t1);
   setcolor(1);
   outtextxy(521,460,t1);
   setcolor(8);
   outtextxy(520,460,t1);
end;

{ ------------------------------------------------------------------- }

procedure updatpunkte(punkte,gesamt:lvec);
var t1,t2:string;
    i:integer;
begin
   for i:=1 to nmax do begin
      rectfill(312,424+i*18,349,433+i*18,14);
      rectfill(432,424+i*18,476,433+i*18,14);
      Str(punkte[i]:4,t1);
      Str(gesamt[i]:5,t2);
      setcolor(1);
      outtextxy(313,424+i*18,t1);
      outtextxy(433,424+i*18,t2);
      setcolor(8);
      outtextxy(312,424+i*18,t1);
      outtextxy(432,424+i*18,t2);
   end;
end;

{ ------------------------------------------------------------------- }

procedure initfeld(var f:feld);
var i,j,k,h,e:integer;
begin
randomize;
k:=0;
h:=xmax div 2;
for i:=1 to h do for j:=1 to ymax do begin
   inc(k);
   f[i,j]:=k;
   f[i+h,j]:=k;
end;
for i:=1 to xmax do for j:=1 to ymax do begin
   cram[i,j]:=0;
   k:=succ(random(1000) mod xmax);
   h:=succ(random(1000) mod ymax);
   e:=f[i,j];
   f[i,j]:=f[k,h];
   f[k,h]:=e;
end;
for i:=1 to xmax do for j:=1 to ymax do
putimage(i*dx+ox,j*dy+oy,ima[0].p_data^,normalput);
end;

{ ------------------------------------------------------------------- }

procedure zeiger(dran:integer);
begin
if dran=1 then begin
   rectfill(16,456,47,471,13);
   putimage(16,440,ima[33].p_data^,normalput);
end else begin
   rectfill(16,440,47,455,13);
   putimage(16,456,ima[33].p_data^,normalput);
end;
end;

{ ------------------------------------------------------------------- }

procedure auswertung(var dran,ofx,ofy,typ,mx,my:integer;
                     var f:feld; var punkte,gesamt:lvec);
var i,j,k,x,y:integer;
begin
   x:=(mx-ox) div dx;
   y:=(my-oy) div dy;
   if f[x,y]=0 then begin
      sound(100);
      delay(50);
      nosound;
   end else begin
      cram[x,y]:=f[x,y];
      putimage(x*dx+ox,y*dy+oy,ima[f[x,y]].p_data^,normalput);
      if typ=0 then begin { 1.Wahl }
         ofx:=x;
         ofy:=y;
         typ:=f[x,y];
         f[x,y]:=0;
      end else begin { 2.Wahl }
         if f[x,y]=typ then begin
            cram[x,y]:=-f[x,y];
            punkte[dran]:=punkte[dran]+10;
            gesamt[dran]:=gesamt[dran]+10;
            updatpunkte(punkte,gesamt);
            f[x,y]:=0;
            typ:=0;
            sound(5000);
            delay(5);
            nosound;
         end else begin
            dran:=succ(dran mod nmax);
            f[ofx,ofy]:=typ;
            typ:=0;
            sound(50);
            delay(5);
            nosound;
            delay(5000);
            putimage(x*dx+ox,y*dy+oy,ima[0].p_data^,normalput);
            putimage(ofx*dx+ox,ofy*dy+oy,ima[0].p_data^,normalput);
         end;
      end;
   end;
end;

{ ------------------------------------------------------------------- }

procedure compimove(var dran,level:integer);
var i,j,x,y,x1,x2,y1,y2:integer;
begin
   { nach Dubletten suchen: }
   x1:=0;
   x2:=0;
   for i:=1 to xmax do for j:=1 to ymax do if cram[i,j]>0 then begin
      for x:=1 to xmax do for y:=1 to ymax do if cram[x,y]>0 then
      if (i<>x) or (j<>y) then if cram[x,y]=cram[i,j] then begin
         if level>random(10) then begin
            x1:=x; y1:=y; x2:=i; y2:=j;
         end;
      end;
   end;
   if x1>0 then begin
      typ:=0;
      mx:=x1*dx+ox; my:=y1*dy+oy;
      auswertung(dran,ofx,ofy,typ,mx,my,f,punkte,gesamt);
      mx:=x2*dx+ox; my:=y2*dy+oy;
      auswertung(dran,ofx,ofy,typ,mx,my,f,punkte,gesamt);
   end else begin

      repeat { 1.Chip }
         x1:=succ(random(1000) mod xmax);
         y1:=succ(random(1000) mod ymax);
      until f[x1,y1]>0;
      typ:=0;
      mx:=x1*dx+ox; my:=y1*dy+oy;
      auswertung(dran,ofx,ofy,typ,mx,my,f,punkte,gesamt);

      { 2.Chip }
      for i:=1 to xmax do for j:=1 to ymax do if f[i,j]>0 then
      if cram[i,j]=typ then begin
         x2:=i; y2:=j;
      end;
      while x2=0 do begin
         i:=succ(random(1000) mod xmax);
         j:=succ(random(1000) mod ymax);
         if f[i,j]>0 then begin
            x2:=i; y2:=j;
         end;
      end;
      mx:=x2*dx+ox; my:=y2*dy+oy;
      auswertung(dran,ofx,ofy,typ,mx,my,f,punkte,gesamt);
   end;
end;

{ ================================================================= }

begin
   screenaufbau(ok);
   if ok then begin
      initimas;
      initstructures;
      level:=11;

      if paramcount>0 then begin
         val(paramstr(1),level,i);
         if level<0 then level:=0;
         if level>10 then level:=11;
         igad[2].p_specialinfo^.buff:='Compi';

         with igad[2] do begin
             rectfill(x,y,x+pred(width),y+height-2,15);
             setcolor(1);
             outtextxy(x+9,y+4,p_specialInfo^.buff);
             setcolor(0);
             outtextxy(x+8,y+4,p_specialInfo^.buff);
         end;
      end;

      initmouse;
      runde:=0;
      ende:=false;
      for i:=1 to nmax do gesamt[i]:=0;
      while not ende do begin
         inc(runde);
         updatrunde(runde);
         for i:=1 to nmax do punkte[i]:=0;
         updatpunkte(punkte,gesamt);
         dran:=1;
         typ:=0;
         aus:=false;
         initfeld(f);
         while not (ende or aus) do begin
            zeiger(dran);
            temp:=igad[dran].p_specialinfo^.buff;
            if length(temp)>0 then
            for i:=1 to length(temp) do temp[i]:=upcase(temp[i]);
            if (temp='COMPI') and (typ=0) then begin
               compimove(dran,level);
               delay(1000);
               aus:=true;
               for j:=1 to xmax do for k:=1 to ymax do
               if f[j,k]>0 then aus:=false;
            end else begin

               if keypressed then ende:=readkey=#27 else begin
                  gadgetup(addr(igad[1]),k,mx,my);
                  case k of
                  1,2: begin
                       getstring(igad[k]);
                       with igad[k] do begin
                          rectfill(x,y,x+pred(width),y+height-2,15);
                          setcolor(1);
                          outtextxy(x+9,y+4,p_specialInfo^.buff);
                          setcolor(0);
                          outtextxy(x+8,y+4,p_specialInfo^.buff);
                       end;
                    end;
                 3: aus:=true;
                 4: ende:=true;
                 5: begin
                       auswertung(dran,ofx,ofy,typ,mx,my,f,punkte,gesamt);
                       if typ=0 then begin
                          aus:=true;
                          for j:=1 to xmax do for k:=1 to ymax do
                          if f[j,k]>0 then aus:=false;
                       end;
                    end;
                 end; { case }

               end;  { not keypressed }
            end;
         end;
         if not ende then begin
            screen2;
            gadgetup(addr(igad[1]),k,mx,my);
            case k of
            1,2: begin
                    getstring(igad[k]);
                    with igad[k] do begin
                       rectfill(x,y,x+pred(width),y+height-2,15);
                       setcolor(1);
                       outtextxy(x+9,y+4,p_specialInfo^.buff);
                       setcolor(0);
                       outtextxy(x+8,y+4,p_specialInfo^.buff);
                    end;
                 end;
            4: ende:=true;
            end;
         end;
      end;
      textmode(3);
   end else writeln( 'Grafik-Error');
end.






